//***********************************************************************/
//*                                                                     */
//*     IF-50 API Sample Program                                        */
//*                                                      2010/2/22      */
//*      Copyright(c) 2012  TEXIO TECHNOLOGY CORPORATION                */
//***********************************************************************/

#pragma once

using namespace System;
using namespace System::Collections::Generic;
using namespace System::Text;
using namespace System::Runtime::InteropServices;


    /// <summary>
    /// TEXIO USB Driver API
    /// </summary>
ref struct IF_60
{
    //********************************************************************************
    //   \̐錾
    //********************************************************************************
    //j^[f[^\
    [StructLayout(LayoutKind::Sequential)]
    ref struct MONITOR_DATA
    {
        double Current;     // dj^[l
        double Voltage;     // dj^[l
        double Wattage;     // d̓j^[l
    };

    //d׃[hݒf[^\
    [StructLayout(LayoutKind::Sequential)]
    ref struct MODE_DATA
    {
        int Mode;          // d׃[hݒ
        int Reference;      // Rg[t@Xݒ
    };

    // XCb`OԐݒf[^\
    [StructLayout(LayoutKind::Sequential)]
    ref struct TIME_DATA
    {
        double Ta;          // Ԃݒ
        double Tb;          // Ԃݒ
    };

    //gbLOݒf[^\
    [StructLayout(LayoutKind::Sequential)]
    ref struct TRACK_DATA
    {
        int Ch_A;           // bg|`
        int Ch_B;           // bg|a
        int Ch_C;           // bg|b
        int Ch_D;           // bg|c
    };

    // A[f[^\
    [StructLayout(LayoutKind::Sequential)]
    ref struct ALARM_DATA
    {
        int Eta;            // OA[
        int Oha;            // I[o[q[gA[
        int Ova_A;
        int Ova_B;
        int Ova_C;
        int Ova_D;
        int Oca_A;
        int Oca_B;
        int Oca_C;
        int Oca_D;
        int Ora_A;
        int Ora_B;
        int Ora_C;
        int Ora_D;
    };

    // ~bgf[^\
    [StructLayout(LayoutKind::Sequential)]
    ref struct LIMIT_DATA
    {
        int Current_A;
        int Current_B;
        int Current_C;
        int Current_D;
        int Power_A;
        int Power_B;
        int Power_C;
        int Power_D;
    };

    // bgf[^\
    [StructLayout(LayoutKind::Sequential)]
    ref struct CH_DATA
    {
        int Ch_A;           // bg|`
        int Ch_B;           // bg|a
        int Ch_C;           // bg|b
        int Ch_D;           // bg|c
    };

    //********************************************************************************
    //  `oh錾
    //********************************************************************************
    [DllImport("IF_50.dll")]
    static int LW_DeviceOpen(int Class, int BoardAdrs, int PcAdrs, int SysAdrs);

    [DllImport("IF_50.dll")]
    static int LW_DeviceClose(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_DeviceRefresh(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_SetTimeOut(int DeviceId, int Time);

    [DllImport("IF_50.dll")]
    static int LW_SetMainInput(int DeviceId, int Flag);

    [DllImport("IF_50.dll")]
    static int LW_GetMainInput(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_SetInputSelect(int DeviceId, int CH, int Flag);

    [DllImport("IF_50.dll")]
    static int LW_GetInputSelect(int DeviceId, int CH);

    [DllImport("IF_50.dll")]
    static int LW_SetPresetNumber(int DeviceId, int Preset);

    [DllImport("IF_50.dll")]
    static int LW_GetPresetNumber(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_SavePreset(int DeviceId, int Src, int Dest);

    [DllImport("IF_50.dll")]
    static int LW_GetMonitor(int DeviceId, int CH, MONITOR_DATA% Monitor);

    [DllImport("IF_50.dll")]
    static int LW_SetMonitorSelect(int DeviceId, int Flag);

    [DllImport("IF_50.dll")]
    static int LW_GetMonitorSelect(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_SetDisplaySelect(int DeviceId, int CH);

    [DllImport("IF_50.dll")]
    static int LW_GetDisplaySelect(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_SetLoadMode(int DeviceId, int Preset, int CH, int Mode, int Ref);

    [DllImport("IF_50.dll")]
    static int LW_GetLoadMode(int DeviceId, int Preset, int CH, MODE_DATA% ModeData);

    [DllImport("IF_50.dll")]
    static int LW_SetLoadValue(int DeviceId, int Preset, int CH, double Data);

    [DllImport("IF_50.dll")]
    static int LW_GetLoadValue(int DeviceId, int Preset, int CH, double% Data);

    [DllImport("IF_50.dll")]
    static int LW_SetSiemensValue(int DeviceId, int Preset, int CH, int Data);

    [DllImport("IF_50.dll")]
    static int LW_GetSiemensValue(int DeviceId, int Preset, int CH, int% Data);

    [DllImport("IF_50.dll")]
    static int LW_SetCurrentLimit(int DeviceId, int Preset, int CH, double Data);

    [DllImport("IF_50.dll")]
    static int LW_GetCurrentLimit(int DeviceId, int Preset, int CH, double% Data);

    [DllImport("IF_50.dll")]
    static int LW_SaveLoadValue(int DeviceId, int Preset, int CH);

    [DllImport("IF_50.dll")]
    static int LW_SaveCurrentLimit(int DeviceId, int Preset, int CH);

    [DllImport("IF_50.dll")]
    static int LW_SaveMemoryData(int DeviceId, int Object);

    [DllImport("IF_50.dll")]
    static int LW_SetSwSelect(int DeviceId, int CH, int Flag);

    [DllImport("IF_50.dll")]
    static int LW_GetSwSelect(int DeviceId, int CH);

    [DllImport("IF_50.dll")]
    static int LW_SetSwFreq(int DeviceId, int Freq);

    [DllImport("IF_50.dll")]
    static int LW_GetSwFreq(int DeviceId, int% Freq);

    [DllImport("IF_50.dll")]
    static int LW_SetSwDuty(int DeviceId, int Duty);

    [DllImport("IF_50.dll")]
    static int LW_GetSwDuty(int DeviceId, int% Duty);

    [DllImport("IF_50.dll")]
    static int LW_SetSwTime(int DeviceId, double Ta, double Tb);

    [DllImport("IF_50.dll")]
    static int LW_GetSwTime(int DeviceId, TIME_DATA% Time);

    [DllImport("IF_50.dll")]
    static int LW_SetSwMethod(int DeviceId, int Flag);

    [DllImport("IF_50.dll")]
    static int LW_GetSwMethod(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_SetDelayFunction(int DeviceId, int Flag);

    [DllImport("IF_50.dll")]
    static int LW_GetDelayFunction(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_SetDelayTime(int DeviceId, int CH, double Time);

    [DllImport("IF_50.dll")]
    static int LW_GetDelayTime(int DeviceId, int CH, double% Time);

    [DllImport("IF_50.dll")]
    static int LW_SetTrackFunction(int DeviceId, int Flag);

    [DllImport("IF_50.dll")]
    static int LW_GetTrackFunction(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_SetTrackDirection(int DeviceId, int ChA, int ChB, int ChC, int ChD);

    [DllImport("IF_50.dll")]
    static int LW_GetTrackDirection(int DeviceId, TRACK_DATA% Track);

    [DllImport("IF_50.dll")]
    static int LW_SetTrackMode(int DeviceId, int Mode);

    [DllImport("IF_50.dll")]
    static int LW_GetTrackMode(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_SetTrackValue(int DeviceId, double Data);

    [DllImport("IF_50.dll")]
    static int LW_GetTrackValue(int DeviceId, double% Data);

    [DllImport("IF_50.dll")]
    static int LW_ResetAlarm(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_GetAlarm(int DeviceId, ALARM_DATA% Alarm);

    [DllImport("IF_50.dll")]
    static int LW_GetLimit(int DeviceId, LIMIT_DATA% Limit);

    [DllImport("IF_50.dll")]
    static int LW_SetOperationTimeOut(int DeviceId, int Time);

    [DllImport("IF_50.dll")]
    static int LW_GetOperationTimeOut(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_SetLocal(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_SetLocalLockOut(int DeviceId, int Flag);

    [DllImport("IF_50.dll")]
    static int LW_GetLocalLockOut(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_GetIdNumber(int DeviceId);

    [DllImport("IF_50.dll")]
    static int LW_GetChExist(int DeviceId, CH_DATA% ChData);

    //********************************************************************************
    //   萔錾
    //********************************************************************************

    //foCX
    static const int GPIB = 1;         // foha
    static const int USB = 2;          // tra

    //G[tO
    static const int DEV_ERR = -1;      // foCXG[
    static const int TO_ERR = -2;      // ^CAEgG[
    static const int PAR_ERR = -3;      // p[^G[
    static const int RCV_ERR = -4;      // MG[

    //tO
    static const int XOFF = 0;          // nee
    static const int XON = 1;           // nm

    //\؂ւtO
    static const int VOLT = 0;          // d^d\
    static const int WATT = 1;          // d^d͕\

    //bgݒl
    static const int Ch_A = 1;          // bg|`
    static const int Ch_B = 2;          // bg|a
    static const int Ch_C = 3;          // bg|b
    static const int Ch_D = 4;          // bg|c

    //vZbgݒl
    static const int PR_1 = 1;          // vZbgԍP
    static const int PR_2 = 2;          // vZbgԍQ
    static const int PR_3 = 3;          // vZbgԍR
    static const int PR_4 = 4;          // vZbgԍS

    //d׃[hݒl
    static const int M_CCH = 1;         // bb[hAdWugv
    static const int M_CCL = 2;         // bb[hAdWukv
    static const int M_CRH = 3;         // bq[hAdWugv
    static const int M_CRL = 4;         // bq[hAdWukv
    static const int M_CVH = 5;         // bu[hAdWugv
    static const int M_CVL = 6;         // bu[hAdWukv
    static const int M_CPHL = 7;        // bo[hAdWugvAdWukv
    static const int M_CPHH = 8;        // bo[hAdWugvAdWugv
    static const int M_CPLL = 9;        // bo[hAdWukvAdWukv
    static const int M_CPLH = 10;       // bo[hAdWukvAdWugv
    static const int M_SHORT = 11;      // V[g[h

    //Rg[t@Xݒl
    static const int REF_IN = 0;        // dRg[
    static const int REF_EXT = 1;       // OdRg[

    //ۑΏۃf[^ݒl
    static const int OBJ_FREQ = 1;      // rvg
    static const int OBJ_DUTY = 2;      // rvf[eB
    static const int OBJ_TAB = 3;       // rvԂA
    static const int OBJ_DELAY = 4;     // fBC
    static const int OBJ_TRACK = 5;     // gbLOݒ

    //XCb`O@ݒl
    static const int SW_FREQ = 0;       // gf[eB
    static const int SW_TAB = 1;        // Ԃ

    //gbLOݒl
    static const int TRC_NO = 0;        // gbLO
    static const int TRC_PLUS = 1;      //u{vgbLO
    static const int TRC_MINUS = 2;     //u|vgbLO

    //gbLO[hݒl
    static const int TRC_PERCENT = 0;   // gbLO[h
    static const int TRC_ABS = 1;       // ΒlgbLO[h

    //[JbNAEgݒl
    static const int LOCK_FREE = 0;     // \
    static const int LOCK_OUT = 1;      // s
};
